//3 #pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <cstdint>
#include <array>
#include <queue>
#include <stack>
using namespace std;
using i64 = int64_t;

struct Node {
    vector<Node*> child;
    Node *parent = nullptr;

    int id;
    int depth = 0;
    int maxd = 0;

    i64 ch_count = 0;
};
vector<Node*> v;

i64 UpWalk(Node* nd) {
    i64 dd = nd->depth - 1;
    i64 md = nd->maxd - dd;

    while (nd->parent) {
        Node*pa = nd->parent;

        for (auto n : pa->child) {
            if (n != nd)
                md = max<i64>(md, n->maxd);
        }

        nd = pa;
    }
    return md;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    i64 n, k, t;
    cin >> n >> k >> t;

    v.resize(n);

    for (int i = 0; i < n; ++i) {
        v[i] = new Node();
        v[i]->id = i;
    }

    for (int i = 0; i < n - 1; ++i) {
        int from, to;
        cin >> from >> to;
        from--;
        to--;
        v[from]->child.push_back(v[to]);
        v[to]->child.push_back(v[from]);
    }

    if (t == 0) {
#pragma  region BFS depth calc
        { // bfs
            vector<bool> used(n, 0);
            queue<Node *> q;
            stack<Node *> back;

            q.push(v[0]);
            v[0]->depth = 0;
            used[0] = 1;

            while (!q.empty()) {
                auto top = q.back();
                q.pop();

                for (auto nd : top->child)
                    if (!used[nd->id]) {
                        used[nd->id] = 1;

                        q.push((nd));
                        nd->maxd = nd->depth = top->depth + 1;
                        nd->parent = top;
                    }

                back.push((top));
            }

            while (!back.empty()) {
                auto top = back.top();
                back.pop();

                if (top->parent)
                    top->parent->maxd = max(top->parent->maxd, top->maxd);
            }
        }

        // clean	parents

        for (auto nd : v) {
            if (!nd->parent) continue;
            int pid = -1;
            for (int i = 0; i < nd->child.size(); i++)
            {
                if (nd->parent == nd->child[i]) {
                    pid = i;
                    break;
                }
            }

            if (pid == -1) continue; //wtf?????????????????/

            if (pid != nd->child.size() - 1)
                swap(nd->child.back(), nd->child[pid]);

            nd->child.pop_back();
        }
#pragma  endregion

        i64 md = -10;
        for (int i = 0; i < n; ++i) {
            md = UpWalk(v[i]);
        }

        cout << md;
    }

    return 0;
}