//#pragma optimize("Ofast")

#include <iostream>
#include <cmath>
#include <numeric>
#include <algorithm>
#include <vector>
#include <cstdint>
#include <set>
#include <cassert>
#include <map>
using namespace std;

#ifdef MYC
#define dPRINT(a) {cout << "DEBUG " << a << endl;}
#else
#define dPRINT(a)
#endif

using i64 = int64_t;

vector<char> eratosphene(1e6+3, false);
inline bool prime(int id){
    assert(id <= eratosphene.size());

    return eratosphene[id];
}

bool check(int a, int b){
    if(a<b)
        swap(a,b);
    return a%b || prime(a/b);
}

int main() {
    eratosphene[0] =
    eratosphene[1] = 1;

    for (int i = 2; i < eratosphene.size(); i++)
        if (!eratosphene[i])
            for (int j = i * 2; j < eratosphene.size(); j += i)
                eratosphene[j] = 1;
    dPRINT("Eratosphene done");

    int n;
    cin >> n;

    dPRINT("1 2" << check(1,2));
    dPRINT("1 3" << check(1,3));
    dPRINT("1 4" << check(1,4));

    vector<int> a(n);
    for (auto &_: a)cin >> _;

    if (n == 1) {
        cout << 1 << endl;
        return 0;
    }

    vector<int> s = a;
    sort(s.begin(), s.end());
    s.erase(unique(s.begin(), s.end()), s.end());

    int m = s.size();

    map<int, char> mp;
    mp[s[0]] = 2;

    set<int> small, big;
    big.insert((s.front()));

    for (int i = 1; i < m; ++i) // rough
        if(check(s.front(), s[i])) {
            mp[s[i]] = 2;
            big.insert(s[i]);
        }else {
            small.insert(s[i]);
            mp[s[i]] = 1;
        }

    for (auto l = small.begin(); l!=small.end(); ++l){
        auto r = l;

        for(r++; r!=small.end(); ++r){
            if(!check(*r, *l)){
                mp[*r] = 2;

                big.insert(*r);
                small.erase(r);
            }
        }
    }
    for (auto l = big.begin(); l!=big.end(); ++l){
        auto r = l;

        for(r++; r!=big.end(); ++r){
            if(!check(*r, *l)){
                mp[*r] = 1;

                small.insert(*r);
                big.erase(r);
            }
        }
    }

    for(auto _: a){
        cout << (int)mp[_] << ' ';
    }

    return 0;
}