#pragma optimize("Ofast")

#include <iostream>
#include <cmath>
#include <numeric>
#include <algorithm>
#include <vector>
#include <cstdint>
#include <set>
#include <cassert>
#include <map>
using namespace std;

#ifdef MYC
#define dPRINT(a) {cout << "DEBUG " << a << endl;}
#else
#define dPRINT(a)
#endif

using i64 = int64_t;

struct State{
    i64 alive, frozen;
    i64 time;

    i64 summary() const{
        return alive + frozen;
    }
};

enum {ADD=1, MUL=2};

int main() {
    i64 n,m;

    cin >> n >> m;

    vector<pair<i64, int>> events(n+n);

    for (int i = 0; i < n; ++i) {
        cin >> events[i].first;
        events[i].second = ADD;
    }
    for (int i = 0; i < n; ++i) {
        cin >> events[i+n].first;
        events[i+n].second=MUL;
        events[i+n].first += events[i].first;
    }

    sort(events.begin(), events.end());

    vector<State> states;
    states.push_back({0,0,0});

    for (int i = 0; i < n*2; ++i) {
        auto prev = states.back();
        State curr = prev;
        curr.time = events[i].first;

        curr.alive *= 1LL << (curr.time - prev.time);

        if(events[i].second==ADD)
            curr.frozen++;
        else{
            curr.frozen--;
            curr.alive+=2;
        }

        if(prev.time == curr.time)
            states.back() = curr;
        else
            states.push_back(curr);
    }

    int it=0;

    {
        i64 l = 0, r = states.size();

        while (r-l>1) {
            auto mid = (r + l) / 2;

            if (states[mid].summary() <= m)
                l = mid;
            else
                r = mid;
        }

        it = l;
    }

    if(states[it].summary()==m){
        cout << states[it].time << endl;
        return 0;
    }

    if(it == states.size()-1){
        i64 b = states.back().alive;
        i64 time = states.back().time;

        while (b*2 <= m){
            if(b*2 < b){
                throw 1;
            }

            b*=2;
            time++;
        }

        if(b==m)
            cout << time<<endl;
        else
            cout << -1 << endl;

        return  0;
    }else{
        auto [alive, frozen, time] = states[it];

        while(time < states[it+1].time){
            if(alive + frozen > m)
            {
                cout << -1 << endl;
                return 0;
            }
            if(alive + frozen == m){
                cout << time << endl;;
                return 0;
            }

            alive*=2;
            time++;
        }

        cout << -1 << endl;
        return 0;
    }

    return 0;
}